#┌─────────────────────────────────────────────────────────────────────────────┐
#│ SDaRT - System Diagnostics and Repair Tool                                  │
#│ ==========================================                                  │
#│ File   : sdart-rs/.gitlab-ci.yml                                            │
#│ License: Mozilla Public License 2.0                                         │
#│ URL    : https://gitlab.com/shivanandvp/sdart-rs                            │
#│ Authors:                                                                    │
#│     1. shivanandvp <shivanandvp@rebornos.org>                               │
#│     2.                                                                      │
#│ -----                                                                       │
#│ Description:                                                                │
#│                                                                             │
#│                                                                             │
#│ -----                                                                       │
#│ Last Modified: Sun, 21st November 2021 6:58:08 PM                           │
#│ Modified By  : shivanandvp                                                  │
#│ -----                                                                       │
#│ 1. Copyright (c) 2021 shivanandvp <shivanandvp@rebornos.org>                │
#│ 2.                                                                          │
#└─────────────────────────────────────────────────────────────────────────────┘

stages:
  - common

test-code:
  stage: common
  image: archlinux:base-devel
  script:
    - pacman --needed --noconfirm -Sy gtk4 rustup
    - rustup toolchain install nightly
    - rustup default nightly
    - cargo build --verbose
    - mkdir builds
    - cp -r target/* builds/ 
    - cargo test
    - cargo install cargo-tarpaulin
    - cargo tarpaulin --ignore-tests
  allow_failure: false
  artifacts:
    paths:
      - builds

pages:
  stage: common
  image: archlinux:base-devel
  script:
    - pacman --needed --noconfirm -Sy gtk4 rustup
    - rustup toolchain install nightly
    - rustup default nightly
    - cargo doc --document-private-items
    - rm -rf public/* # clear out old files
    - cp -r target/doc/. public/ # copy the web pages to the public directory
  allow_failure: false
  artifacts:
    paths:
    - public